From 27f2d81cb5fafd2934389fab56baf0b4368f9f46 Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Mon, 10 Apr 2023 22:34:22 +0700
Subject: [PATCH 08/13] Initial FD788 v2.0 support.

---
 forward/forward-core.c  |  1 +
 forward/forward-fd788.c | 73 ++++++++++++++++++++++++++++++++++++++---
 include/fd788_reg.h     | 32 +++++++++++++++++-
 3 files changed, 101 insertions(+), 5 deletions(-)

diff --git a/forward/forward-core.c b/forward/forward-core.c
index f33ae6a..b6c3314 100644
--- a/forward/forward-core.c
+++ b/forward/forward-core.c
@@ -66,6 +66,7 @@ static const struct pci_device_id forward_pci_ids[] = {
 	{ PCI_DEVICE(0x1C1F, 0x001F), .driver_data = FORWARD_FD940 },
 	{ PCI_DEVICE(0x1C1F, 0x0020), .driver_data = FORWARD_FD2110 },
 	{ PCI_DEVICE(0x1C1F, 0x0021), .driver_data = FORWARD_FD722 },
+	{ PCI_DEVICE(0x1C1F, 0x0022), .driver_data = FORWARD_FD788 },
 	{},
 };
 
diff --git a/forward/forward-fd788.c b/forward/forward-fd788.c
index 5bf1916..1a75946 100644
--- a/forward/forward-fd788.c
+++ b/forward/forward-fd788.c
@@ -22,6 +22,7 @@
 #include "forward-vdma.h"
 
 #include "forward-si532x.h"
+#include "forward-si534x.h"
 #include "fd788_reg.h"
 
 #include <linux/delay.h>
@@ -68,18 +69,82 @@ static bool fd788_i2c_xfer(struct forward_dev *dev, u8 bus, bool read, uint8_t a
 	return !i2c.cs && !i2c.nack;
 }
 
+static bool fd788_spi_xfer(struct forward_dev *dev, u8 bus, u8 *tx, int tx_bits, u8 *rx,
+			   int rx_bits)
+{
+	int bits = max(tx_bits, rx_bits);
+	int word_count = (bits - 1) / 32 + 1;
+	int byte_count = (bits - 1) / 8 + 1;
+	int last_word_bits = bits % 32;
+
+	FD788_SPIControl ctl;
+	FD788_SPIData data;
+	int i;
+
+	ctl.bus = bus + 1;
+	ctl.rxBits = rx_bits;
+	ctl.txBits = tx_bits;
+	FD788_SPIControl_W(dev->csr, ctl);
+
+	for (i = 0; i < word_count; i++) {
+		int j;
+
+		if ((i * 8) < tx_bits) {
+			u32 value = 0;
+			if (tx) {
+				for (j = 0; j < 4; j++) {
+					if (i * 4 + j < byte_count)
+						value |= tx[i * 4 + j] << ((3 - j) * 8);
+				}
+			} else
+				value = 0xFFFFFFFF;
+			data.data = value;
+			FD788_SPIData_W(dev->csr, data);
+		}
+
+		if ((i * 8) < rx_bits) {
+			data = FD788_SPIData_R(dev->csr);
+			if (i == (word_count - 1))
+				data.data <<= (32 - last_word_bits) % 32;
+
+			if (rx) {
+				for (j = 0; j < 4; j++) {
+					if (i * 4 + j < byte_count)
+						rx[i * 4 + j] = (data.data >> ((3 - j) * 8)) & 0xFF;
+				}
+			}
+		}
+	}
+
+	ctl.bus = 0;
+	ctl.rxBits = 0;
+	ctl.txBits = 0;
+	FD788_SPIControl_W(dev->csr, ctl);
+
+	return true;
+}
+
 static int fd788_init(struct forward_dev *dev)
 {
-	dev->i2c_xfer = &fd788_i2c_xfer;
+	FD788_DynamicVersion v = FD788_DynamicVersion_R(dev->csr);
 
-	forward_si532x_init(dev, &dev->pll, 0, FD788_PLL_ADDRESS, 2);
+	if (v.hardware >= 2) {
+		dev->spi_xfer = &fd788_spi_xfer;
+		forward_si534x_init(dev, &dev->pll, 1, 3);
+	} else {
+		dev->i2c_xfer = &fd788_i2c_xfer;
+		forward_si532x_init(dev, &dev->pll, 0, FD788_PLL_ADDRESS, 2);
+	}
 
 	return 0;
 }
 
 static void fd788_fini(struct forward_dev *dev)
 {
-	forward_si532x_fini(dev, &dev->pll);
+	if (((dev->fw_version >> 24) & 0xF) >= 2)
+		forward_si534x_fini(dev, &dev->pll);
+	else
+		forward_si532x_fini(dev, &dev->pll);
 }
 
 static void fd788_reboot(struct forward_dev *dev)
@@ -112,7 +177,7 @@ static void fd788_read_id(struct forward_dev *dev)
 		dev->hard_id = (u64)dev->soft_id;
 	}
 
-	dev->fw_version = (v.major << 24) | (v.minor << 16) | v.revision;
+	dev->fw_version = (v.hardware << 24) | (v.minor << 16) | v.revision;
 }
 
 static void fd788_enable_interrupts(struct forward_dev *dev, u32 interrupts)
diff --git a/include/fd788_reg.h b/include/fd788_reg.h
index ab670c2..52f8158 100644
--- a/include/fd788_reg.h
+++ b/include/fd788_reg.h
@@ -205,6 +205,36 @@ FD788_SoftID __always_inline FD788_SoftID_R(uint32_t *csr)
 	return *((FD788_SoftID *)&r);
 }
 
+typedef struct _FD788_SPIControl {
+	uint32_t txBits : 12;
+	uint32_t rxBits : 12;
+	uint32_t bus : 8;
+} __attribute__((packed)) FD788_SPIControl;
+
+#define FD788_SPIControl_A (0xD2)
+
+void __always_inline FD788_SPIControl_W(uint32_t *csr, FD788_SPIControl v)
+{
+	__write_reg(csr, FD788_SPIControl_A, *((uint32_t *)&v));
+}
+
+typedef struct _FD788_SPIData {
+	uint32_t data : 32;
+} __attribute__((packed)) FD788_SPIData;
+
+#define FD788_SPIData_A (0xD3)
+
+FD788_SPIData __always_inline FD788_SPIData_R(uint32_t *csr)
+{
+	uint32_t r = __read_reg(csr, FD788_SPIData_A);
+	return *((FD788_SPIData *)&r);
+}
+
+void __always_inline FD788_SPIData_W(uint32_t *csr, FD788_SPIData v)
+{
+	__write_reg(csr, FD788_SPIData_A, *((uint32_t *)&v));
+}
+
 typedef struct _FD788_StaticVersion {
 	uint32_t revision : 16;
 	uint32_t minor : 8;
@@ -520,7 +550,7 @@ FD788_AnalogVSyncTime __always_inline FD788_AnalogVSyncTime_R(uint32_t *csr)
 typedef struct _FD788_DynamicVersion {
 	uint32_t revision : 16;
 	uint32_t minor : 8;
-	uint32_t major : 4;
+	uint32_t hardware : 4;
 	uint32_t project : 4;
 } __attribute__((packed)) FD788_DynamicVersion;
 
-- 
2.39.1


